
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>代码生成利器：IDEA 强大的 Live Templates / 憋错料</title>

    <meta name="description" content="代码生成利器：IDEA 强大的 Live Templates Java 开发过程经常需要编写有固定格式的代码,例如说声明一个私有变量, logger 或者 bean 等等.对于这种小范围的代码生成,我们可以利用 IDEA 提供的 Live Templates 功能.刚开始觉得它只是一个简单的 Code Snippet ,后来发现它支持变量函数配置,可以支持很复杂的代码生成.下面我来介绍一下 Live Templates 的用法. 基本使用 IDEA 自带很多常用的动态模板,在 Java 代码中输入 fori ,回车就会出现 for (int i = 0;">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">代码生成利器：IDEA 强大的 Live Templates</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>Java 开发过程经常需要编写有固定格式的代码，例如说声明一个私有变量，&nbsp;<code>logger</code>&nbsp;或者&nbsp;<code>bean</code>&nbsp;等等。对于这种小范围的代码生成，我们可以利用 IDEA 提供的&nbsp;<code>Live Templates</code>&nbsp;功能。刚开始觉得它只是一个简单的&nbsp;<code>Code Snippet</code>&nbsp;，后来发现它支持变量函数配置，可以支持很复杂的代码生成。下面我来介绍一下&nbsp;<code>Live Templates</code>&nbsp;的用法。</p>
<h2>基本使用</h2>
<p>IDEA 自带很多常用的动态模板，在 Java 代码中输入&nbsp;<code>fori</code>&nbsp;，回车就会出现</p>
<pre>for (int i = 0; i &lt; ; i++) {

}
</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS50dWljb29sLmNvbS96MjZ6eXlmLmdpZg==.jpg">按&nbsp;<code>Tab</code>&nbsp;可以在各个空白处跳转，手动填值。</p>
<h2>自定义 Template</h2>
<p>官方自带模板毕竟不能满足我们个人编码风格的需要，&nbsp;<code>Live Templates</code>&nbsp;提供了变量函数的方式供我们自定义。</p>
<h3>简单用法</h3>
<p>新增自定义模板，首先需要填写触发单词（即 Abbreviation），描述是可选的，然后定义模板的上下文，点击&nbsp;<code>define</code>&nbsp;选择&nbsp;<code>Java</code>&nbsp;，这样在编辑 Java 的时候就会触发当前模板，定义完上下文之后，就可以填写模板了。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMC50dWljb29sLmNvbS91aVFKRjMzLmdpZg==.jpg">下面列举几个我常用的简单模板</p>
<pre>==========
&lt;out&gt;
----------
System.out.println($END$)
==========
&lt;pfs&gt;
----------
private final static String $varName$  = "$var$";`
==========
&lt;privateField&gt;
----------
/**
 * $COMMENT$
 */
@Getter
@Setter
private $TYPE$ $NAME$;
==========
&lt;main&gt;
----------
public static void main(String[] args) {
     $END$
}
==========
</pre>
<p>模板支持变量的定义，使用&nbsp;<code>$$</code>&nbsp;包围的字符表示一个变量。&nbsp;<code>$END$</code>&nbsp;是一个特殊的预定义变量，表示光标最后跳转的位置。每个变量的位置都可以跳转过去。</p>
<h3>高级用法</h3>
<p>如果你用过 vim 的&nbsp;<code>Code Sinppet</code>&nbsp;插件，你会发现模板里面是可以执行函数的，强大的&nbsp;<code>Live Templates</code>&nbsp;当然也支持，而且 IDEA 能够感知代码的语义，例如说当前编辑的函数的参数。但这一点就能够让我们玩出花来。我们从易到难来研究模板函数的功能。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS50dWljb29sLmNvbS9ubVVORjNuLmdpZg==.jpg"></p>
<p>前面我们提到的变量可以绑定函数，配置方式如上图所示。</p>
<h4>快速声明变量</h4>
<p>声明变量是一个常用的操作，特别是需要声明变量需要加注解，注释的时候，这些代码写起来就很枯燥。下面是我定义的模板：</p>
<pre>&lt;osgiRef&gt;
----------
/**
 * $END$
 */
@OsgiReference
@Setter
private $TYPE$ $NAME$;
</pre>
<p>乍一看这个模板跟我上面定义的&nbsp;<code>privateField</code>&nbsp;差不多，唯一的不同在于我给这些变量绑定了函数。</p>
<ol>
<li><code>clipboard()</code>&nbsp;：返回当前粘贴板的字符串</li>
<li><code>decapitalize()</code>&nbsp;：将输入的字符串首字母变为小写</li>
</ol>
<p>下面我们演示一下，我们先拷贝当前类名，然后输入&nbsp;<code>osgiRef</code>&nbsp;<br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMi50dWljb29sLmNvbS9WM016QTNGLmdpZg==.jpg"></p>
<h4>快速声明 logger</h4>
<p>声明 logger 也是一个常用的操作，上面我们是利用了粘贴函数来快速声明变量，现在我们来利用另一个函数&nbsp;<code>className()</code>&nbsp;，顾名思义，它的作用就是返回当前类名。</p>
<pre>&lt;logger&gt;
----------
/** logger */
private static final Logger LOGGER = LoggerFactory.getLogger($CLASS$.class);
</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS50dWljb29sLmNvbS8yMmFRVm43LmdpZg==.jpg"></p>
<h4>最强大的 groovyScript()</h4>
<p>如果说上面用到的函数提供的能力有限，不够灵活，那么&nbsp;<code>groovyScript()</code>&nbsp;提供了一切你想要的能力，它支持执行 Groovy 脚本处理输入，然后输出处理后的字符串。</p>
<pre>groovyScript("code", ...)

|  code   |   一段Groovy代码或者Groovy脚本代码绝对路径    |
|  ...    |   可选入参，这些参数会绑定到`_1, _2, _3, ..._n`, 在 Groovy 代码中使用。|
</pre>
<p>下面我们来看一下它的实际应用。</p>
<h4>快速 bean 配置</h4>
<p>新增一个服务都要在 Spring 中注册一个 bean，一般这个配置无非就是将指明&nbsp;<code>id</code>&nbsp;和&nbsp;<code>class</code>&nbsp;，由于我们是在 xml 中配置，所以不能利用&nbsp;<code>className()</code>&nbsp;函数，但是我们可以利用&nbsp;<code>clipboard()</code>函数获取到类的全引用，在 IDEA 中我们直接右键类名，点击&nbsp;<code>Copy Reference</code>&nbsp;就行。然后执行 groovy 脚本获取类名。</p>
<pre>&lt;bean&gt;
----------
&lt;bean id="$id$" class="$REF$" /&gt;
</pre>
<p><code>id</code>&nbsp;绑定&nbsp;<code>decapitalize(groovyScript("_1.tokenize(‘.‘)[-1]", clipboard()))</code>&nbsp;，首先取&nbsp;<code>clipboard()</code>&nbsp;的值得到类的全引用，然后执行 groovy 代码&nbsp;<code>_1.tokenize(‘.‘)[-1]</code>&nbsp;（按&nbsp;<code>.</code>&nbsp;分割为字符串数组，然后取最后一个即可得到类名，然后用&nbsp;<code>decapitalize()</code>&nbsp;将首字母小写即可得到&nbsp;<code>id</code>&nbsp;。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMi50dWljb29sLmNvbS9pcXFZemF5LmdpZg==.jpg"></p>
<h4>快速打印当前上下文信息</h4>
<p>打印错误日志的时候需要打印当前上下文信息的，例如说入参，有时候入参很多的时候，写起来很痛苦，好在有模板函数&nbsp;<code>methodParameters()</code>&nbsp;，返回当前函数参数的列表，当然这个列表我们不能直接使用，需要结合&nbsp;<code>groovyScript</code>&nbsp;对它进行转化。</p>
<pre>&lt;printContext&gt;
---------------
LogUtil.$TYPE$(LOGGER, "$MSG$ " + $params$);
</pre>
<p>将&nbsp;<code>params</code>&nbsp;绑定到&nbsp;<code>groovyScript("‘\"‘ + _1.collect { it + ‘ = [\" + ‘ + it + ‘ + \"]‘}.join(‘, ‘) + ‘\"‘", methodParameters())</code>&nbsp;，就能够自动将当前函数的参数格式化后输出。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMi50dWljb29sLmNvbS95WUZGSmZRLmdpZg==.jpg"></p>
<h2>总结</h2>
<p>上面我们简单介绍了常用的模板函数，其实 IDEA 还有很多其它模板函数，具体参考&nbsp;<a href="https://www.jetbrains.com/help/idea/2016.3/creating-and-editing-template-variables.html" rel="external nofollow noreferrer">Creating and Editing Template Variables</a>&nbsp;。IDEA 是一个很强大的工具，善用工具能够极大的提高工作效率，将精力投入到关键的事情上，而不是将时间浪费在编写重复代码上面。一些更高级的用法还有待大家去发掘。最后推广一波我写的代码生成插件&nbsp;<a href="https://github.com/x-hansong/CodeMaker" rel="external nofollow noreferrer">CodeMaker</a>&nbsp;，好好利用也能节省很多重复编写代码的时间。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-06 14:40:16 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/int/" title="int">int</a>, <a href="https://www.biecuoliao.com/tag/%e4%b8%aa%e4%ba%ba/" title="个人">个人</a>, <a href="https://www.biecuoliao.com/tag/com/" title="&period;com">&period;com</a>, <a href="https://www.biecuoliao.com/tag/%e5%b8%b8%e7%94%a8/" title="常用">常用</a>, <a href="https://www.biecuoliao.com/tag/ati/" title="ati">ati</a>, <a href="https://www.biecuoliao.com/tag/main/" title="main">main</a>, <a href="https://www.biecuoliao.com/tag/collect/" title="collect">collect</a>, <a href="https://www.biecuoliao.com/tag/%e9%ab%98%e7%ba%a7/" title="高级">高级</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>代码生成利器：IDEA 强大的 Live Templates的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/B0Rnk70.html" rel="bookmark">GitHub上整理的一些工具，求补充</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://segmentfault.com/q/1010000002404545 技术站点 Hacker News:非常棒的针对编程的链接聚合网站 Programming reddit:同上 MSDN:微软相关的官方技术集中地,主要是文档类 infoq:企业级应用,关注软件开发领域 OSChina:开源技术社区,开源方面做的不错哦 cnblogs,51cto,csdn:常见的技术社区,各有专长 stackoverflow:IT技术问答网站 GitHub:全球最大的源代码管理平台,很多知名开源			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/r4JpPB0.html" rel="bookmark">GitHub上整理的一些工具</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				GitHub上整理的一些工具 GitHub   2015-11-19 10:10:47 发布 您的评价:       0.0   收藏     5收藏 技术站点 Hacker News:非常棒的针对编程的链接聚合网站 Programming reddit:同上 MSDN:微软相关的官方技术集中地,主要是文档类 infoq:企业级应用,关注软件开发领域 OSChina:开源技术社区,开源方面做的不错哦 cnblogs,51cto,csdn:常见的技术社区,各有专长 stackoverflow:IT			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vvKzk3.html" rel="bookmark">技术资源集合</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				网上看到的资源集合,挺有用的,在这里加上自己的收藏分享一下. 技术站点 stackoverflow:全球第一IT技术问答网站 GitHub:全球最大的源代码管理平台,很多知名开源项目都在上面,如Linux内核 Hacker News:非常棒的针对编程的链接聚合网站 Programming reddit:同上 MSDN:微软相关的官方技术集中地,主要是文档类 MDN:前端标准这里都可以查到 infoq:企业级应用,关注软件开发领域 OSChina:开源技术社区,开源方面做的不错哦 cnblogs,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41gB8G0.html" rel="bookmark">成为专业程序员路上用到的各种优秀资料、神器及框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近想着怎么把自己的知识体系进行整理起来,使用思维导图进行描述,对自己以后的发展也有一个更深的认识,更快的提升自己:看到了下面这篇文章,感觉非常实用,从语言到框架都非常全面,自己也可以继续补充,也是对自己知识体系的一个补充吧. 前言 成为一名专业程序员的道路上,需要坚持练习.学习与积累,技术方面既要有一定的广度,更要有自己的深度. 笔者作为一位tool mad,将工作以来用到的各种优秀资料.神器及框架整理在此,毕竟好记性不如烂键盘,此项目可以作为自己的不时之需. 本人喜欢折腾,记录的东西也比较杂			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz87LW3.html" rel="bookmark">GitHub 开源工具整理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				技术站点 Hacker News:非常棒的针对编程的链接聚合网站 Programming reddit:同上 MSDN:微软相关的官方技术集中地,主要是文档类 infoq:企业级应用,关注软件开发领域 OSChina:开源技术社区,开源方面做的不错哦 cnblogs,51cto,csdn:常见的技术社区,各有专长 stackoverflow:IT技术问答网站 GitHub:全球最大的源代码管理平台,很多知名开源项目都在上面,如Linux内核, OpenStack等免费的it电子书:http://			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wREV10.html" rel="bookmark">GitHub上整理的一些工具【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				技术站点 Hacker News:非常棒的针对编程的链接聚合网站 Programming reddit:同上 MSDN:微软相关的官方技术集中地,主要是文档类 infoq:企业级应用,关注软件开发领域 OSChina:开源技术社区,开源方面做的不错哦 cnblogs,51cto,csdn:常见的技术社区,各有专长 stackoverflow:IT技术问答网站 GitHub:全球最大的源代码管理平台,很多知名开源项目都在上面,如Linux内核, OpenStack等免费的it电子书:http://			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDdWRwM.html" rel="bookmark">【真正福利】成为专业程序员路上用到的各种优秀资料、神器及框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载,原地址:http://www.cnblogs.com/jasondan/p/6380597.html 据说看到好文章不推荐的人,服务器容易宕机!本文版权归翟士丹(Stan Zhai)和博客园共有,欢迎转载,但未经作者同意必须保留此段声明,且在文章页面明显位置给出原文链接,否则保留追究法律责任的权利. 好东西不是随便收集下,发篇博文,骗些点赞的!积累了5年多的东西,是时候放出来跟大家见见面了. 或许有的园友在14年的时候收藏过我的一篇&quot;工欲善其事.必先利其器&quot;的博文,时隔3年,已经			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pzvmP0.html" rel="bookmark">（转）&quest;工欲善其事，必先利其器&quest;&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				附:我在GitHub上整理的一些资料 技术站点 Hacker News:非常棒的针对编程的链接聚合网站 Programming reddit:同上 MSDN:微软相关的官方技术集中地,主要是文档类 infoq:企业级应用,关注软件开发领域 OSChina:开源技术社区,开源方面做的不错哦 cnblogs,51cto,csdn:常见的技术社区,各有专长 stackoverflow:IT技术问答网站 GitHub:全球最大的源代码管理平台,很多知名开源项目都在上面,如Linux内核,OpenStac			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEvJGP0.html" rel="bookmark">成为专业程序员路上有用的各种优秀资料、神器及框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录 资料篇 技术站点 必看书籍 大牛博客 GitHub篇 工具篇 平台工具 常用工具 第三方服务 爬虫相关(好玩的工具) 安全相关 Web服务器性能/压力测试工具/负载均衡器 大数据处理/数据分析/分布式工具 Web前端 语言篇 Scala Java Python Swift .NET C &amp; C++ 其他 游戏开发相关 日志聚合,分布式日志收集 RTP,实时传输协议与音视频 资料篇 技术站点 在线学习:Coursera.edX.Udacity.MIT公开课.MOOC学院.慕课网 Hacker			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/L3r8mwM.html" rel="bookmark" class="title">12 款不能少的使网页浏览获得的最佳体验Chrome 扩展</a>
					<div>
						原文地址:http://whosmall.com/?post=414 本文标签: Chrome扩展 网页浏览体验 引擎划词翻译工具 Chrome浏览器 相信不少朋友和我一样,每安装新的操作系统之后,都 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWyYKB3.html" rel="bookmark" class="title">备忘录：hadoop技术一点积累</a>
					<div>
						1.hbase的rowkey是按字典排序的,我看有的资料建议rowkey设计不应该是自增的,应该和这个字典排序相关吧 2.hbase的数据存储是按照region来的,region的设计前段时间在坐飞机 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3q5pXz3.html" rel="bookmark" class="title">【mysql】mysql内置函数</a>
					<div>
						mysql常用内置函数 1.mysql字符串函数 contact 字符串连接函数 mysql&gt;select contact(&quot;he&quot;,'llo');# hello lcase ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmGxgQ3.html" rel="bookmark" class="title">【模板】树的重心   洛谷P1364 医院设置</a>
					<div>
						P1364 医院设置 题目描述 设有一棵二叉树,如图: 其中,圈中的数字表示结点中居民的人口.圈边上数字表示结点编号,现在要求在某个结点上建立一个医院,使所有居民所走的路程之和为最小,同时约定,相邻接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6N7vrM.html" rel="bookmark" class="title">记一次Oracle冷备恢复的过程</a>
					<div>
						一.故障来临 某日中午,市电意外中断,机房UPS电源由于负载过重而未接管供电,所有服务器全部重启...... 待所有服务器重启后,正在逐一检查设备和业务运行情况时,意外发生了.一台年代久远的HP PC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YGVQy4.html" rel="bookmark" class="title">Javascript&period;Reactjs-5-prop-validation-and-proptypes</a>
					<div>
						Props &amp; PropTypes 1. Props &quot;Props are the mechanism React uses to let components communicat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz8bmW3.html" rel="bookmark" class="title">林锐《软件工程思想》读后感</a>
					<div>
						读了林锐博士的&lt;软件工程思想&gt;,我对软件工程这门学科又有了更加深刻的认识.这本书不过虽然并没有什么长篇大论,但是作者的文风幽默而且亲和.特别是在写程序员的生活和工作已经融为一体时,即便现在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXeBj3.html" rel="bookmark" class="title">nefu 462 fib组合</a>
					<div>
						nefu 462 fib组合 (斐波那契数列的通项公式以及推倒过程) 分类: 数学2014-05-21 10:27 190人阅读 评论(0) 收藏 举报 题目链接:http://acm.nefu.ed ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47NnpY3.html" rel="bookmark" class="title">什么是闭包</a>
					<div>
						一个函数f1的返回值是另一个函数f2,而f2中包含了对f1中变量的引用,使得当调用f1()完成后,由于f2还需要使用f1中的变量,使得回收机制并没有回收f1中的变量.此时的f2就构成了一个闭包. fu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38LqPW3.html" rel="bookmark" class="title">Android&mdash;&mdash;onCreate&lpar; &rpar;方法详解（转）</a>
					<div>
						android开发之onCreate( )方法详解 onCreate( )方法是android应用程序中最常见的方法之一,那么,我们在使用onCreate()方法的时候应该注意哪些问题呢? 先看看Go ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NqjPV3.html" rel="bookmark" class="title">android 实现漫天飞舞雪花以及下雨天的效果</a>
					<div>
						前言: 这个效果实现的原作者是国外一位大神.我在其基础上测试,以及在代码上加了不少注释,以及局部修改.后面我有根据漫天飞舞雪花,实现下雨天场景的效果.原作者项目还是android studio版本的. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OZNeP0.html" rel="bookmark" class="title">SVN历史版本比较中文乱码</a>
					<div>
						SVN历史版本比较中文乱码 将Workspace的编码改为UTF-8即可					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jeoBEM.html" rel="bookmark" class="title">队列的链式存储结构</a>
					<div>
						1 链队列的存储结构 将对头指针front指向链队列的头结点,队尾指针rear指向终端结点. 空队列时,头指针front和尾指针rear都指向头结点. 链队列的存储结构为: typedef int Q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Rmjl5M.html" rel="bookmark" class="title">初见微服务之服务注册与发现</a>
					<div>
						什么是服务注册与发现 微服务将传统的&quot;巨石&quot;应用拆分成一个一个的组件应用,每个组件应用提供特定的服务,可以是一个,也可以是多个,并且组件所含服务应该是可以动态扩展的,随着时间推移. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wBYrQ0.html" rel="bookmark" class="title">AngularJS中监视Scope变量以及外部调用Scope方法</a>
					<div>
						在AngularJS中,有时候需要监视Scope中的某个变量,因为变量的改变会影响一些界面元素的显示.有时,也希望通过jQuery调用Scope的某个方法. 比如以下场景: &lt;div&gt; & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXlmmQM.html" rel="bookmark" class="title">C&num; 如何用多个字符串来切分字符串并去除空格</a>
					<div>
						using System; using System.Collections.Generic; using System.Linq; using System.Text; using System.D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jrwyZ0.html" rel="bookmark" class="title">总结oninput、onchange与onpropertychange事件的使用方法和差别</a>
					<div>
						前端页面开发的非常多情况下都须要实时监听文本框输入,比方腾讯微博编写140字的微博时输入框hu9i动态显示还能够输入的字数. 过去一般都使用onchange/onkeyup/onkeypress/on ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47X2j6M.html" rel="bookmark" class="title">vim基础详解</a>
					<div>
						目录: 什么是vim Vim能做什么 如何学习vim 如何用vim打开一个文件 Vim的三种模式 插入模式 命令模式 扩展命令模式 光标移动 在命令模式下 删除,复制,粘贴 扩展命令模式 可视化模式  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JjVQn4.html" rel="bookmark" class="title">点击获取验证码效果</a>
					<div>
						1 var Btn = document.getElementById('btn'); 2 var star = 10; 3 4 Btn.onclick = function(){ 5 var tim ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xeLPk3.html" rel="bookmark" class="title">C&num;分页</a>
					<div>
						/// &lt;summary&gt;           /// &lt;/summary&gt;            /// &lt;param name=&quot;field&quot;&g ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
